//#################################################################
// fontsoft.c
//
// Text mit Software Fonts schreiben
//
// Special Version fr APEs Fontgenerator
//
// hk@holger-klabunde.de
// http://www.holger-klabunde.de
//#################################################################
// 08.12.2007
//#################################################################
// Compiler AVR-GCC 4.1.2
//#################################################################
#include <avr/pgmspace.h>

#include "lcd.h"
#include "param.h"
#include "fontsoftape.h"



#include "fontcorsiva_12.h"
#include "font12x16.h"
#include "arial24fontbold.h"
#include "arial26bold.h"
#include "arial14x28bold.h" //Wir nehmen diese
#include "impact54boltitalic.h" 
#include "impact32italic.h"
#include "comic32.h"


#define FIXED	1
#define PROP	2




unsigned char fontwidth,fontheight,fonttype;   //Breite,Hhe in Pixeln
unsigned const char *font_s;

//########################################################################
void SetFont(unsigned char num)
//Die Zuordnung mte mal nach Gre umsortiert werden
//########################################################################
{
 switch(num)
  {
  //FESTE ZEICHENBREITE
  // case 1: fontwidth=5; fontheight=7; font_s=Font5x7; fonttype=FIXED; break;
   
  // case 2: fontwidth=6; fontheight=8; font_s=Font6x8; fonttype=FIXED; break;
   
  // case 3: fontwidth=1; fontheight=1; font_s=arial8x8bi; fonttype=PROP; break;  //b=Bold/Fett i=Kursiv 
   
  // case 3: fontwidth=22; fontheight=36; font_s=Font22x36; fonttype=FIXED; break;
 
   case 4: fontwidth=12; fontheight=16; font_s=Font12x16; fonttype=FIXED; break;
   
 
 //VARIBLE ZEICHENBREITE
 
 
   case 5: fontwidth=1; fontheight=1; font_s=Corsiva_12; fonttype=PROP; break;
 
   case 6: fontwidth=1; fontheight=1; font_s=arial24bold; fonttype=PROP; break;
    
   case 7: fontwidth=1; fontheight=1; font_s=impact32italic; fonttype=PROP; break;  
   
 //  case 8: fontwidth=1; fontheight=1; font_s=comic32; fonttype=PROP; break;
    
	case 10: fontwidth=1; fontheight=1; font_s=arial26bold; fonttype=PROP; break;
 
 	case 11: fontwidth=1; fontheight=1; font_s=arial28bold; fonttype=PROP; break;
   case 9: fontwidth=1; fontheight=1; font_s=impact54boltitalic; fonttype=PROP; break;  
   
    
   default: fontwidth=0; fontheight=0; fonttype=0; break;
  }
}

//########################################################################
//Schreibt ein einzelnes Zeichen an Position x,y
//Fr proportional Fonts mit variabler Breite aus APEs Fontgenerator.
//void LCDSoftCharProp(unsigned char ch, unsigned char xpos, unsigned char ypos)
void LCDSoftCharProp(unsigned char ch, unsigned short xpos, unsigned short ypos)
//########################################################################
{
 unsigned int fontoffset,fontstart;
 unsigned char i,j,k,by,mask, fontvbytes;

 //fontwidth, fontheight je nach Zeichen setzen zur Cursorberechnung
 //fontheight setzen 
 //SPACE ist als Zeichen nicht in der Tabelle !

 fontheight = pgm_read_byte(&font_s[3]);

 //SPACE nicht zeichnen, oder besser doch ? Htte APE doch blo ein SPACE in die Tabelle mit reingelegt ;)
 if(ch==' ') { fontwidth = pgm_read_byte(&font_s[2]); return; }

 if(ch < pgm_read_byte(&font_s[4]) ) return; // Zeichennummer zu klein
 if(ch > ( pgm_read_byte(&font_s[4]) + pgm_read_byte(&font_s[5]) ) ) return; // Zeichennummer zu gro
 
 fontwidth = pgm_read_byte(&font_s[6 + ch - ' ']); 

 fontstart = 6 + (unsigned int)pgm_read_byte(&font_s[5]); // Beginn der Fontdaten

 // addiere alle Zeichenbreiten bis zum aktuellen Zeichen
 fontoffset = 0;
 for(i=0; i<(ch - ' '); i++) fontoffset += pgm_read_byte(&font_s[6 + (unsigned int)i]);

 //Quickhack, muss man mal besser machen
 //Zeichenhhe in Bytes
 if(fontheight<=8) fontvbytes=1;
 if(fontheight>8 && fontheight<=16) fontvbytes=2;
 if(fontheight>16 && fontheight<=24) fontvbytes=3;
 if(fontheight>24 && fontheight<=32) fontvbytes=4;
 if(fontheight>32 && fontheight<=40) fontvbytes=5;
 if(fontheight>40 && fontheight<=48) fontvbytes=6;
 if(fontheight>48 && fontheight<=56) fontvbytes=7;
 if(fontheight>56 && fontheight<=64) fontvbytes=8;

 fontoffset *= fontvbytes; // alle davorliegenden Zeichen berspringen
 fontoffset += fontstart;  // Nun haben wir die Startaddresse des Zeichens

 for(k=0; k<fontvbytes; k++)
  {
   for(i=0; i<fontwidth; i++) //ber die Breite des Zeichens
    {
     by=pgm_read_byte(&font_s[fontoffset++]); //Ein Byte des Zeichens holen

     mask=0x01;               //Bei D0 anfangen
     for(j=0; j<8; j++)
      {
       lcd_setpixel(xpos+i,ypos + k * 8 + j,(by&mask));
       
	   mask<<=1; //Nchstes Bit
      
	  }//for j

    }//for i

   for(j=0; j<8; j++) // virtual spacing Spalte, 1 pixel addieren
    {
     lcd_setpixel(xpos+i,ypos + k * 8 + j,0);
 

	}//for j

  }//for k

 fontwidth++; // virtual spacing Spalte, 1 pixel addieren
}






//########################################################################
//Schreibt ein einzelnes Zeichen an Position x,y
//Fr APE fixed Fonts mit fester Breite.
//void LCDSoftChar(unsigned char ch, unsigned char xpos, unsigned char ypos)
void LCDSoftChar(unsigned char ch, unsigned short xpos, unsigned short ypos)
//########################################################################
{
unsigned char by,mask;
unsigned char i,j;
 
 ch-=' '; // APE font

 for(i=0; i<fontwidth; i++) //ber die Breite des Zeichens
  {
   if(fontheight<=8)
    {
     by=pgm_read_byte(&font_s[ch*fontwidth+i]); //Ein Byte des Zeichens holen
     mask=0x01;               //Bei D0 anfangen

     for(j=0; j<8; j++)
      {
     lcd_setpixel(xpos+i,ypos+j,(by&mask));
       mask<<=1; //Nchstes Bit
      }//for j
    }//if(fontheight<=8)
    
   if(fontheight>8 && fontheight<=16)
    {
     by=pgm_read_byte(&font_s[ch*2*fontwidth+2*i]); //Ein Byte des Zeichens holen oberer Teil

     mask=0x01;               //Bei D0 anfangen
     for(j=0; j<8; j++)
      {
       lcd_setpixel(xpos+i,ypos+j,(by&mask));
       mask<<=1; //Nchstes Bit
      }//for j

     by=pgm_read_byte(&font_s[ch*2*fontwidth+2*i+1]); //Ein Byte des Zeichens holen unterer Teil

     mask=0x01;               //Bei D0 anfangen
     for(j=0; j<8; j++)
      {
       lcd_setpixel(xpos+i,ypos+j+8,(by&mask));
       mask<<=1; //Nchstes Bit
      }//for j
    }//if(fontheight>8....

   if(fontheight>16 && fontheight<=24)
    {
     by=pgm_read_byte(&font_s[ch*2*fontwidth+3*i]); //Ein Byte des Zeichens holen oberer Teil

     mask=0x01;               //Bei D0 anfangen
     for(j=0; j<8; j++)
      {
       lcd_setpixel(xpos+i,ypos+j,(by&mask));
       mask<<=1; //Nchstes Bit
      }//for j

     by=pgm_read_byte(&font_s[ch*2*fontwidth+3*i+1]); //Ein Byte des Zeichens holen mittlerer Teil

     mask=0x01;               //Bei D0 anfangen
     for(j=0; j<8; j++)
      {
       lcd_setpixel(xpos+i,ypos+j+8,(by&mask));
       mask<<=1; //Nchstes Bit
      }//for j

     by=pgm_read_byte(&font_s[ch*2*fontwidth+3*i+2]); //Ein Byte des Zeichens holen unterer Teil

     mask=0x01;               //Bei D0 anfangen
     for(j=0; j<8; j++)
      {
       lcd_setpixel(xpos+i,ypos+j+16,(by&mask));
       mask<<=1; //Nchstes Bit
      }//for j

    }//if(fontheight>16....

   if(fontheight>24 && fontheight<=32)
    {
     by=pgm_read_byte(&font_s[ch*2*fontwidth+4*i]); //Ein Byte des Zeichens holen oberer Teil

     mask=0x01;               //Bei D0 anfangen
     for(j=0; j<8; j++)
      {
       lcd_setpixel(xpos+i,ypos+j,(by&mask));
       mask<<=1; //Nchstes Bit
      }//for j

     by=pgm_read_byte(&font_s[ch*2*fontwidth+4*i+1]); //Ein Byte des Zeichens holen mittlerer Teil

     mask=0x01;               //Bei D0 anfangen
     for(j=0; j<8; j++)
      {
       lcd_setpixel(xpos+i,ypos+j+8,(by&mask));
       mask<<=1; //Nchstes Bit
      }//for j

     by=pgm_read_byte(&font_s[ch*2*fontwidth+4*i+2]); //Ein Byte des Zeichens holen unterer Teil

     mask=0x01;               //Bei D0 anfangen
     for(j=0; j<8; j++)
      {
       lcd_setpixel(xpos+i,ypos+j+16,(by&mask));
       mask<<=1; //Nchstes Bit
      }//for j

     by=pgm_read_byte(&font_s[ch*2*fontwidth+4*i+3]); //Ein Byte des Zeichens holen unterer Teil

     mask=0x01;               //Bei D0 anfangen
     for(j=0; j<8; j++)
      {
       lcd_setpixel(xpos+i,ypos+j+24,(by&mask));
       mask<<=1; //Nchstes Bit
      }//for j

    }//if(fontheight>24....

  }//for i
}

//########################################################################
//Schreibt einen Text an Position x,y
//Mit automatischem Zeilenvorschub falls der Text zu lang war.
//Noch keine Steuerzeichen wie TAB,CR,LF integriert
//void LCDSoftText(char *__putstr, unsigned char xpos, unsigned char ypos)
void LCDSoftText(char *__putstr, unsigned short xpos, unsigned short ypos)

//########################################################################
{
 char __ps;
 //unsigned char xp,yp;
unsigned short xp,yp;
 if(fonttype==0) return; //Kein Font ausgewhlt

 xp=xpos; yp=ypos;
 
 while((__ps = *__putstr))
  {
   __putstr++;
   if (__ps== 0) break;
   if(fonttype==FIXED) LCDSoftChar(__ps,xp,yp);
   if(fonttype==PROP) LCDSoftCharProp(__ps,xp,yp);
   xp+=fontwidth; //Nchstes Zeichen
   if(xp>=XSIZE) { xp=0; yp+=fontheight; } //Nchste Zeile
  }
}

//########################################################################
//Zeigt eine bersicht der im Font enthaltenen Zeichen
void ShowSoftFont(unsigned char num, unsigned short xpos, unsigned short ypos)
//########################################################################
{
 unsigned short i,xp,yp;
 
// ClearScreen();
xp=xpos; yp=ypos;
 //xp=0; yp=0;
 SetFont(num);
 
 for(i=0x20; i<128; i++)
  {
   
   if(fonttype==FIXED) LCDSoftChar(i,xp,yp);
   if(fonttype==PROP) LCDSoftCharProp(i,xp,yp);
   xp+=fontwidth; //Nchstes Zeichen
  if(xp>=XSIZE-22) { xp=0; yp+=fontheight; } //Nchste Zeile
 }
}




